Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.jgoodies.forms.builder
Class AbstractButtonPanelBuilder

    java.lang.Object
      com.jgoodies.forms.builder.AbstractBuilder
          com.jgoodies.forms.builder.AbstractButtonPanelBuilder

Direct Known Subclasses:
  ButtonBarBuilder2

    public abstract class AbstractButtonPanelBuilder

extends AbstractBuilder

The abstract superclass for `ButtonBarBuilder2`. Provides a cell cursor for traversing the button bar/stack while components are added. It also offers convenience methods to append logical columns and rows.

TODO: Mention the ButtonStackBuilder2 subclass as soon as it is available.

Since:
  1.2
Version:
  $Revision: 1.11 $
Author:
  Karsten Lentzsch

Field Summary
`protected static String` | `NARROW_KEY` The client property key used to indicate that a button shall get narrow margins on the left and right hand side.

Fields inherited from class com.jgoodies.forms.builder.AbstractBuilder
`currentCellConstraints`

Constructor Summary
`protected` | `AbstractButtonPanelBuilder(FormLayout layout, JPanel container)` Constructs an AbstractButtonPanelBuilder for the given FormLayout and layout container.

Method Summary
`protected Component` | `add(Component component)` Adds a component to the container using the default cell constraints.
`protected void` | `appendColumn(ColumnSpec columnSpec)` Appends the given column specification to the builder's layout.
`protected void` | `appendGlueColumn()` Appends a glue column.
`protected void` | `appendGlueRow()` Appends a glue row.
`protected void` | `appendRelatedComponentsGapColumn()` Appends a column that is the default gap for related components.
`protected void` | `appendRelatedComponentsGapRow()` Appends a row that is the default gap for related components.
`protected void` | `appendRow(RowSpec rowSpec)` Appends the given row specification to the builder's layout.
`protected void` | `appendUnrelatedComponentsGapColumn()` Appends a column that is the default gap for unrelated components.
`protected void` | `appendUnrelatedComponentsGapRow()` Appends a row that is the default gap for unrelated components.
`protected JButton` | `createButton(Action action)` Creates and returns a button that is bound to the given Action.
`protected int` | `getColumn()`
`JPanel` | `getPanel()` Returns the panel used to build the form.
`boolean` | `isLeftToRight()` Returns whether this builder fills the form left-to-right or right-to-left.
`protected void` | `nextColumn()` Moves to the next column, does the same as #nextColumn(1).
`protected void` | `nextRow()` Increases the row by one; does the same as #nextRow(1).
`void` | `setBackground(Color background)` Sets the panel's background color.
`void` | `setBorder(Border border)` Sets the panel's border.
`void` | `setLeftToRight(boolean b)` Sets the form fill direction to left-to-right or right-to-left.
`void` | `setOpaque(boolean b)` Sets the panel's opaque state.

Methods inherited from class com.jgoodies.forms.builder.AbstractBuilder
`createComponentFactory, getColumnCount, getComponentFactory, getContainer, getDefaultComponentFactory, getLayout, getRowCount, setComponentFactory, setDefaultComponentFactory`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### NARROW_KEY

    protected static final String NARROW_KEY

  The client property key used to indicate that a button shall get narrow margins on the left and right hand side.

  This optional setting will be honored by all JGoodies Look&Feel implementations. The Mac Aqua l&f uses narrow margins only. Other look&feel implementations will likely ignore this key and so may render a wider button margin.

  See Also:
    Constant Field Values

Constructor Detail

### AbstractButtonPanelBuilder

    protected AbstractButtonPanelBuilder(FormLayout layout,
                                         JPanel container)

  Constructs an AbstractButtonPanelBuilder for the given FormLayout and layout container.

  Parameters:
    `layout` - the FormLayout to use
    `container` - the layout container
  Throws:
    `NullPointerException` - if `layout` or `container` is `null`

Method Detail

### getPanel

    public final JPanel getPanel()

  Returns the panel used to build the form.

  Returns:
    the panel used by this builder to build the form

### setBackground

    public final void setBackground(Color background)

  Sets the panel's background color.

  Parameters:
    `background` - the color to set as new background
  See Also:
    `JComponent.setBackground(Color)`

### setBorder

    public final void setBorder(Border border)

  Sets the panel's border.

  Parameters:
    `border` - the border to set
  See Also:
    `JComponent.setBorder(Border)`

### setOpaque

    public final void setOpaque(boolean b)

  Sets the panel's opaque state.

  Parameters:
    `b` - true for opaque, false for non-opaque
  Since:
    1.1
  See Also:
    `JComponent.setOpaque(boolean)`

### isLeftToRight

    public final boolean isLeftToRight()

  Returns whether this builder fills the form left-to-right or right-to-left. The initial value of this property is set during the builder construction from the layout container's `componentOrientation` property.

  Returns:
    true indicates left-to-right, false indicates right-to-left
  See Also:
    `setLeftToRight(boolean)`, `ComponentOrientation`

### setLeftToRight

    public final void setLeftToRight(boolean b)

  Sets the form fill direction to left-to-right or right-to-left. The initial value of this property is set during the builder construction from the layout container's `componentOrientation` property.

  Parameters:
    `b` - true indicates left-to-right, false right-to-left
  See Also:
    `isLeftToRight()`, `ComponentOrientation`

### nextColumn

    protected final void nextColumn()

  Moves to the next column, does the same as #nextColumn(1).

### getColumn

    protected int getColumn()

### nextRow

    protected final void nextRow()

  Increases the row by one; does the same as #nextRow(1).

### appendColumn

    protected final void appendColumn(ColumnSpec columnSpec)

  Appends the given column specification to the builder's layout.

  Parameters:
    `columnSpec` - the column specification object to append

### appendGlueColumn

    protected final void appendGlueColumn()

  Appends a glue column.

  See Also:
    `appendRelatedComponentsGapColumn()`, `appendUnrelatedComponentsGapColumn()`

### appendRelatedComponentsGapColumn

    protected final void appendRelatedComponentsGapColumn()

  Appends a column that is the default gap for related components.

  See Also:
    `appendGlueColumn()`, `appendUnrelatedComponentsGapColumn()`

### appendUnrelatedComponentsGapColumn

    protected final void appendUnrelatedComponentsGapColumn()

  Appends a column that is the default gap for unrelated components.

  See Also:
    `appendGlueColumn()`, `appendRelatedComponentsGapColumn()`

### appendRow

    protected final void appendRow(RowSpec rowSpec)

  Appends the given row specification to the builder's layout.

  Parameters:
    `rowSpec` - the row specification object to append

### appendGlueRow

    protected final void appendGlueRow()

  Appends a glue row.

  See Also:
    `appendRelatedComponentsGapRow()`, `appendUnrelatedComponentsGapRow()`

### appendRelatedComponentsGapRow

    protected final void appendRelatedComponentsGapRow()

  Appends a row that is the default gap for related components.

  See Also:
    `appendGlueRow()`, `appendUnrelatedComponentsGapRow()`

### appendUnrelatedComponentsGapRow

    protected final void appendUnrelatedComponentsGapRow()

  Appends a row that is the default gap for unrelated components.

  See Also:
    `appendGlueRow()`, `appendRelatedComponentsGapRow()`

### add

    protected final Component add(Component component)

  Adds a component to the container using the default cell constraints. Note that when building from left to right, this method won't adjust the cell constraints if the column span is larger than 1.

  Parameters:
    `component` - the component to add
  Returns:
    the added component

### createButton

    protected JButton createButton(Action action)

  Creates and returns a button that is bound to the given Action. This is a hook that allows to return customized buttons. For example, the JGoodies `JGButton` configures the accessible name and accessible description from Actions that provide these information.

  This default implementation delegates the button creation to this builder's component factory, if it is an an instance of ComponentFactory (that provides `ComponentFactory2.createButton(Action)`). Otherwise a JButton is created.

  Parameters:
    `action` - provides bound visual properties for the button
  Returns:
    the created button
  Since:
    1.4

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002-2011 JGoodies Karsten Lentzsch. All Rights Reserved.